from flask import Flask, jsonify, request
from flask_cors import CORS

#Llibreries necesaris per Odoo
import xmlrpc.client

#Llibreries per API PVGIS
import requests


#Crear app
app = Flask(__name__)


#Politica de CORS
cors = CORS(app, resources={r"*": {"origins": "*"}})

#Dades de conexio amb external API Odoo 15
url = 'https://odoo-tfg.ecoillesa3.com'
db = 'TFG-Ecoilles'
username = 'jgualr@uoc.edu'
password = 'e51a4b87d0cc04053e3ffc5bb337e2ecd4a6ed9b'

#Inici de sesio i optencio de UID per les seguents consultes
common = xmlrpc.client.ServerProxy('{}/xmlrpc/2/common'.format(url))
uid = common.authenticate(db, username, password, {})


#Models endpont
models = xmlrpc.client.ServerProxy('{}/xmlrpc/2/object'.format(url))




# ----- URLS i funcions api Odoo ---- 
@app.route('/api/test')
def test(): 
    return jsonify('test1')



# -- Clients
#Crear un client
@app.route('/api/client', methods=["POST"])
def newClient2():
    models.execute_kw(db, uid, password, 'res.partner', 'create', [{'name': request.json['name'], 'phone': request.json['phone'], 'email': request.json['email']}])
    return "Client creat correctament"

#Llegir dades d'un client
@app.route('/api/client/<email>', methods=['GET'])
def getClient(email):
    fields = models.execute_kw(db, uid, password, 'res.partner', 'search_read', [[['email', '=', email]]], {'fields': ['phone', 'name', 'vat', 'street', 'city', 'zip'] })
    return jsonify(fields)

#Actualitzar dades d'un client
@app.route('/api/client/', methods=['PATCH'])
def updateClient():
    models.execute_kw(db, uid, password, 'res.partner', 'write', [[request.json['id']], {'name': request.json['name'], 'phone': request.json['phone'], 'vat': request.json['vat'], 'street': request.json['street'], 'city': request.json['city'], 'zip': request.json['zip']}])

    return "OK"


# -- Oportunitats
#Crear oportunitat
@app.route('/api/oportunitys', methods=["POST"])
def newOpportunity2():
    # Cerquem la id de client segons el correu obtingut
    partner_id = models.execute_kw(db, uid, password, 'res.partner', 'search_read', [[['email', '=', request.json['email']]]], {'fields': ['id']})
    partner_id2 = int(partner_id[0]['id']) 

    #Cream el presupost al client corresponent segons la ID
    models.execute_kw(db, uid, password, 'crm.lead', 'create', [{'name': request.json["name"] , 'partner_id': partner_id2, 'description': request.json["formData"] + request.json["calcData"]}])
    return jsonify(request.json)

#Llistar oportunitats del CRM
@app.route('/api/oportunitys/<email>', methods=["GET"] )
def listCRM(email):
    fields = models.execute_kw(db, uid, password, 'crm.lead', 'search_read', [[['email_from', '=', email]]], {'fields': ['create_date', 'stage_id'] })
    return jsonify(fields)






# -- Pressuposts
#Llistar pressuposts
@app.route('/api/sales/<email>', methods=["GET"])
def listSels(email):
    fields = models.execute_kw(db, uid, password, 'sale.order', 'search_read', [[['partner_id.email', '=', email]]], {'fields': ['create_date', 'amount_total', 'amount_untaxed', 'display_name', 'state', 'access_token'] })
    return jsonify(fields)

#Modificar estat d'un pressupost
@app.route('/api/sales', methods=["PATCH"])
def acceptpSale():
    models.execute_kw(db, uid, password, 'sale.order', 'write', [[request.json['id']], {'state': request.json['state']}])

    return "OK"



#   ----------- API2 -------------

#Conexio amb PVGIS
@app.route('/api2/pvgis/<lat>/<lon>/<power>/<angle>/<azim>')
def calcProduction(lat, lon, power, angle, azim):


    url = 'https://re.jrc.ec.europa.eu/api/PVcalc?lat='+lat+'&lon='+lon+'&peakpower='+power+'&angle='+angle+'&aspect='+azim+'&loss=14&outputformat=json'
    r = requests.get(url)
    return r.json()
    




#Run app
if __name__ == '__main__':
    app.run(debug=True)



