import { createRouter, createWebHistory } from 'vue-router'
import HomeView from '../views/HomeView.vue'
import Calculadora from '../views/CalculadoraView.vue'
import { getAuth } from '@firebase/auth'


const routes = [
  {
    path: '/',
    name: 'home',
    component: HomeView
  },
  {
    path: '/calculadoraSolar',
    name: 'CalculadoraView',
    component: Calculadora
  },

  {
    path: '/myDashboard',
    name: 'MyDashboard',
    component: () =>
      import( /* webpackChunkName: "Dashboard" */  '../views/Dashboard.vue'),
    meta: {
      authRequired: true,
    },
  },

  {
    path: '/Auth',
    name: 'AuthView',
    component: () =>
      import( /* webpackChunkName: "AuthView" */  '../views/AuthView.vue'),
  
  },
  {
    path: '/:catchAll(.*)',
    component: () => 
      import(/* webpackChunkName: "ERROR 404" */'../views/404NotFound.vue')
  },



  

]

const router = createRouter({
  history: createWebHistory(process.env.BASE_URL),
  routes
})


// Bloquejar rutes
router.beforeEach((to, from, next) => {
  const rutaAuth = to.matched.some(record => record.meta.authRequired)
  const user = getAuth().currentUser;


  if (rutaAuth && !user) {
    next('/Auth')
  }else{
    next()
  }

})

export default router
